import groovyx.gpars.actor.DynamicDispatchActor
import static groovyx.gpars.GParsExecutorsPool.withPool
import groovy.transform.*

class Accumulator extends DynamicDispatchActor {
  int maxTickers = 1000000
  String highTicker = ''
  double highPrice = 0
  int count = 0
  
  void onMessage(int count) {
    maxTickers = count
  }

  void onMessage(PriceInfo priceInfo) {
    if (priceInfo.price > highPrice) {
      highPrice = priceInfo.price
      highTicker = priceInfo.name
    }
    
    if (++count == maxTickers) {
      println "High Ticker is $highTicker at price $highPrice"
      stop()
    }
  }
}

@Immutable class PriceInfo {
  String name
  double price
}


accumulator = new Accumulator().start()

def tickers = ["AAPL", "AMGN", "AMZN", "BAC", "BMY",
"CAT", "C", "CMCSA", "CSCO", "CVX", "DELL", "DIS", "DOW", "EMC", "FDX", "GD", 
"GE", "GOOG", "HAL", "HNZ", "HPQ", "IBM", "INTC", "JPM", "KFT", "LMT", "MET", 
"MO", "MSFT", "NKE", "NSC", "ORCL", "PFE", "RTN", "S", "SO","TXN", "USB", 
"VZ", "WMT"]

accumulator << tickers.size()

withPool(40) { service ->
  tickers.each { ticker ->
    service.submit { 
      accumulator << new PriceInfo(ticker, YahooFinance.getPrice(ticker)) }
  }
}

accumulator.join(10, java.util.concurrent.TimeUnit.SECONDS)
